function love.load()

love.graphics.setCaption("Philip Invaders!")

-- music that loops
music = love.audio.newSource("music.ogg") -- if "static" is omitted, LOVE will stream the file from disk, good for longer music tracks
music:setLooping(true)

love.audio.play(music)

-- sounds
shooting = love.audio.newSource("laser.mp3", static)

game_over = love.audio.newSource("game_over.mp3", static)

booms = love.audio.newSource("boom.mp3", static)

     game_over_flag = "false" -- used to play game over sound only once when it's game over

	 score = 0 -- used to produce explosion
	 
	bg = love.graphics.newImage("bg.png")
	
	bg2 = love.graphics.newImage("bg2.png")
	
	boom = love.graphics.newImage("boom.gif") -- explosion when a ship is destroyed
	
	base = love.graphics.newImage("base.png") -- base graphics
	
	bgScroll = {}
	bgScroll.x= 0
	bgScroll.y= -600
	
	bgScroll2 = {}
	bgScroll2.x= 0
	bgScroll2.y= 600
	
	
	exp = {}
	expx = {}
	expy = {}
	
	
	herobg = love.graphics.newImage("hero.png")
    herobg:setFilter("linear", "nearest")
	
	enemybg = love.graphics.newImage("enemy.png")
    enemybg:setFilter("linear", "nearest")
	
        heroes = {} -- holds heroes

	hero = {} -- new table for the hero
	hero.x = 350	-- x,y coordinates of the hero
	hero.y = 480
	hero.width = 3
	hero.height = 1
	hero.speed = 150
	hero.shots = {} -- holds our fired shots


--       table.insert(heroes, hero)  
       heroes[1] = hero

	   
	   
	enemies = {}
	
	for i=0,6 do
		enemy = {}
		enemy.width = 40
		enemy.height = 20
		enemy.x = i * (enemy.width + 60) + 100
		enemy.y = enemy.height + 100
		table.insert(enemies, enemy)
	end
	

-- make timer

	timer = {} -- new table for the hero
	timer["text"] = 0
    
      
	
end

function love.keyreleased(key)
	
	if next(heroes) ~= nil then
	if (key == " ") then
		shoot()
	end
  end	
end

function love.update(dt)

    

    if next(heroes) ~= nil then  -- check for destroyed hero
	-- keyboard actions for our heroes[1]
	if love.keyboard.isDown("left") then
		heroes[1].x = heroes[1].x - heroes[1].speed*dt
	elseif love.keyboard.isDown("right") then
		heroes[1].x = heroes[1].x + heroes[1].speed*dt
	elseif love.keyboard.isDown("up") then
		heroes[1].y = heroes[1].y - heroes[1].speed*dt
    elseif love.keyboard.isDown("down") then 
		heroes[1].y = heroes[1].y + heroes[1].speed*dt		
	end
 end
       
	
	local remEnemy = {}
	local remShot = {}
	
	-- update the shots
	for i,v in ipairs(hero.shots) do
	
		-- move them up up up
		v.y = v.y - dt * 100
		
		-- mark shots that are not visible for removal
		if v.y < 0 then
			table.insert(remShot, i)
		end
		
		-- check for collision with enemies
		for ii,vv in ipairs(enemies) do
			if CheckCollision(v.x,v.y,2,5,vv.x,vv.y,vv.width,vv.height) then
				

				
				-- mark that enemy for removal
				table.insert(remEnemy, ii)
								
				-- mark the shot to be removed
				table.insert(remShot, i)
				
				-- store what enemy will explode and its coordinates
		        table.insert(exp, ii)
                table.insert(expx, enemies[ii].x)				
		        table.insert(expy, enemies[ii].y)
				
			end
		end
		
		
		
	end
	
	
	-- remove the marked enemies
	for i,v in ipairs(remEnemy) do	

		
		-- remove enemy
		table.remove(enemies, v)
		
		score = score + 1 -- scored one!
		
		if next (enemies) == nil then -- recreate enemies
		for i=0,6 do
		enemy = {}
		enemy.width = 40
		enemy.height = 20
		enemy.x = i * (enemy.width + 60) + 100
		enemy.y = enemy.height + 100
		table.insert(enemies, enemy)
	    end
		
	end
		
	end
	
	for i,v in ipairs(remShot) do
		table.remove(hero.shots, v)
	end
	
	
	
	-- update those evil enemies
	for i,v in ipairs(enemies) do
		
		if i % 2 == 1 then
		-- let them fall down slowly		
			
		v.y = v.y + dt * i * 2
		end		
		
		if i % 2 ~= 1 then
		-- let them fall down slowly
		
		if v.x > 300 then		
		
		
		v.x = v.x - dt * i * 2
		v.y = v.y + dt * i * 2
		
        elseif v.x < 300 then
		v.x = v.x + dt * i * 2
		v.y = v.y + dt * i * 2
		
		else
		v.y = v.y + dt * i * 2
		end
		
		end
		
		-- check for collision with ground
		if v.y > 465 then
 
          table.remove(heroes, 1)  -- delete hero
		  
			-- you lose!!!
		end
		
	end

-- update timer only if the game didn't end
if game_over_flag == "false" then
timer["text"] = timer["text"]  + dt

timer["text"] = math.ceil(timer["text"])
end

-- scroll background

bgScroll.y = bgScroll.y + dt * 10
	
	-- redraw background after it has scrolled after a certain point
	if bgScroll.y > 600 then
 
          bgScroll.y = -600                      
			
		end	

bgScroll2.y = bgScroll2.y - dt * 10
	
	-- redraw background after it has scrolled after a certain point
	if bgScroll2.y < 0 then
 
          bgScroll2.y = 600                      
			
		end	

		
	
end -- end of update function


function love.draw()
	
    -- let's draw a background
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(bg)
	
	-- scrolling background 1
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(bg, bgScroll.x, bgScroll.y)
	
	-- scrolling background 2
	
    love.graphics.setColor(255,255,255,255)
	love.graphics.draw(bg2, bgScroll2.x, bgScroll2.y)
	
    -- let's draw some ground
	love.graphics.setColor(255,255,250,255)
	love.graphics.draw(base)

	
	if next(heroes) ~= nil then -- check for destroyed hero
	-- let's draw our hero
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(herobg, heroes[1].x, heroes[1].y,  0, 1, 1, 14, 8)
	end
	-- let's draw our hero shots
	love.graphics.setColor(255,255,255,255)
	for i,v in ipairs(hero.shots) do
		love.graphics.rectangle("fill", v.x, v.y, 2, 5)
	

	
	end
	
	-- let's draw our enemies
	love.graphics.setColor(255,255,255,255)
    
    
  	for i,v in ipairs(enemies) do
	
	
   	love.graphics.draw(enemybg, v.x, v.y,  0, 1, 1, 14, 8)
	

	
	
	
	end

	for i,v in ipairs(exp) do
	
	love.graphics.setColor(255,255,255,255)
   	love.graphics.draw(boom, expx[i], expy[i],  0, 1, 1, 14, 8)

	  table.remove(exp, i)
	  table.remove(expx, i)
	  table.remove(expy, i)
	end 
	
	-- draw game over
	
	if next(heroes) == nil then
	love.graphics.setColor(255,255,255,255)
    love.graphics.print("GAME OVER", 350, 300) --game Ended
	
	if game_over_flag == "false" then
	  love.audio.play(game_over) -- game over sound
    end
	
	game_over_flag = "true"
	
	end
	
-- draw timer

love.graphics.setColor(150,255,255,255)

love.graphics.print("Timer: " .. timer["text"], 0, 0)

-- draw score

love.graphics.print("Score: " .. score, 0, 15)

end -- end of draw function

function shoot()
     
	love.audio.stop(shooting) -- shooting sound, first stop current instance if playing
	love.audio.play(shooting) -- shooting sound, now play new instance
 
	local shot = {}
	shot.x = heroes[1].x + 37 + heroes[1].width/2 -- this is the location of where the bullets fire
	shot.y = heroes[1].y - 10 -- this is the location of where the bullets fire
	
	table.insert(hero.shots, shot)



	
end


function CheckCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or -- Is box1 on the right side of box2?
       box1y > box2y + box2h - 1 or -- Is box1 under box2?
       box2x > box1x + box1w - 1 or -- Is box2 on the right side of box1?
       box2y > box1y + box1h - 1    -- Is b2 under b1?
    then
        return false                -- No collision. Yay!
    else
	    -- play sound effect of ship's destruction	
        love.audio.stop(booms) -- first stop booms sound (because if you don't, it will try to play the sound twice and it won't work)		
		love.audio.play(booms) -- then play it
		return true                 -- Yes collision. Ouch!
    end
end